---
title: EXT_texture_compression_bptc
slug: Web/API/EXT_texture_compression_bptc
tags:
  - API
  - Reference
  - WebGL
  - WebGL extensions
---
<div>{{APIRef("WebGL")}}</div>

<p>The <code>EXT_texture_compression_bptc</code> extension is part of the <a href="/en-US/docs/Web/API/WebGL_API">WebGL API</a> and exposes 4 BPTC compressed texture formats. These compression formats are called <a href="https://docs.microsoft.com/en-us/windows/desktop/direct3d11/bc7-format">BC7</a> and <a href="https://docs.microsoft.com/en-us/windows/desktop/direct3d11/bc6h-format">BC6H</a> in <a href="https://docs.microsoft.com/en-us/windows/desktop/direct3d11/texture-block-compression-in-direct3d-11">Microsoft's DirectX API</a>.</p>

<p>WebGL extensions are available using the {{domxref("WebGLRenderingContext.getExtension()")}} method. For more information, see also <a href="/en-US/docs/Web/API/WebGL_API/Using_Extensions">Using Extensions</a> in the <a href="/en-US/docs/Web/API/WebGL_API/Tutorial">WebGL tutorial</a>.</p>

<div class="note">
<p><strong>Availability:  </strong>Support depends on the system's graphics driver. There is no support on Windows.</p>

<p>This extension is available to both, {{domxref("WebGLRenderingContext", "WebGL1", "", 1)}} and {{domxref("WebGL2RenderingContext", "WebGL2", "", 1)}} contexts.</p>
</div>

<h2 id="Constants">Constants</h2>

<p>The compressed texture formats are exposed by 4 constants and can be used in two functions: {{domxref("WebGLRenderingContext.compressedTexImage2D", "compressedTexImage2D()")}} and {{domxref("WebGLRenderingContext.compressedTexSubImage2D", "compressedTexSubImage2D()")}}.</p>

<dl>
 <dt><code>ext.COMPRESSED_RGBA_BPTC_UNORM_EXT</code></dt>
 <dd>Compresses 8-bit fixed-point data. Each 4x4 block of texels consists of 128 bits of RGBA or image data. See also <a href="https://docs.microsoft.com/en-us/windows/desktop/direct3d11/bc7-format">BC7 format</a>.</dd>
 <dt><code>ext.COMPRESSED_SRGB_ALPHA_BPTC_UNORM_EXT</code></dt>
 <dd>Compresses 8-bit fixed-point data. Each 4x4 block of texels consists of 128 bits of SRGB_ALPHA or image data. See also <a href="https://docs.microsoft.com/en-us/windows/desktop/direct3d11/bc7-format">BC7 format</a>.</dd>
 <dt><code>ext.COMPRESSED_RGB_BPTC_SIGNED_FLOAT_EXT</code></dt>
 <dd>Compresses high dynamic range signed floating point values. Each 4x4 block of texels consists of 128 bits of RGB data. It only contains RGB data, so the returned alpha value is 1.0. See also <a href="https://docs.microsoft.com/en-us/windows/desktop/direct3d11/bc6h-format">BC6H format</a>.</dd>
 <dt><code>ext.COMPRESSED_RGB_BPTC_UNSIGNED_FLOAT_EXT</code></dt>
 <dd>Compresses high dynamic range unsigned floating point values. Each 4x4 block of texels consists of 128 bits of RGB data. It only contains RGB data, so the returned alpha value is 1.0. See also <a href="https://docs.microsoft.com/en-us/windows/desktop/direct3d11/bc6h-format">BC6H format</a>.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<pre class="brush:js">var ext = gl.getExtension('EXT_texture_compression_bptc');

var texture = gl.createTexture();
gl.bindTexture(gl.TEXTURE_2D, texture);

gl.compressedTexImage2D(gl.TEXTURE_2D, 0, ext.COMPRESSED_RGBA_BPTC_UNORM_EXT, 128, 128, 0, textureData);
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
  </tr>
  <tr>
   <td><a href="https://www.khronos.org/registry/webgl/extensions/EXT_texture_compression_bptc/">EXT_texture_compression_bptc</a></td>
   <td>Community Approved</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p class="hidden">The compatibility table on this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>

<p>{{Compat("api.EXT_texture_compression_bptc")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("WebGLRenderingContext.getExtension()")}}</li>
 <li>{{domxref("WebGLRenderingContext.compressedTexImage2D()")}}</li>
 <li>{{domxref("WebGLRenderingContext.compressedTexSubImage2D()")}}</li>
 <li>{{domxref("WebGLRenderingContext.getParameter()")}}</li>
</ul>
